VBA中画圆为什么不按用户坐标系?
本帖最后由 nitou 于 2018-11-15 09:47 编辑请教一下大家,我在CAD中移动了坐标原点(用UCS命令),手动画圆输入圆心坐标它是相对我UCS为0,0原点的这没错。
但是用VBA画圆时,它的圆心以最初的绝对坐标来画,这是什么原因?
代码如下:
Sub Example_Center()
Dim circObj As AcadCircle
Dim currCenterPt(0 To 2) As Double
Dim newCenterPt(0 To 2) As Double
Dim radius As Double
' Define the initial center point and radius for the circle
currCenterPt(0) = 20: currCenterPt(1) = 30: currCenterPt(2) = 0
radius = 3
' Create the circle in model space
Set circObj = ThisDrawing.ModelSpace.AddCircle(currCenterPt, radius)
ZoomAll
MsgBox "The center point of the circle is " & currCenterPt(0) & ", " & currCenterPt(1) & ", " & currCenterPt(2), vbInformation, "Center 示例"
End Sub
原因就是程序按绝对坐标算啊。你又没指定用户坐标系,如果程序按用户坐标系,那同一个程序在不同的用户坐标系下,画出的图都不一样,岂不是乱套了。既然你需要用用户坐标系,那就算出绝对坐标嘛。 我是想用VBA怎么提取所选对象相对到某点的坐标?
逻辑过程如下:
1.先框选要提取的对象(都是圆);
2.选取一个点为坐标原点;
3.提取1中所有的圆心坐标(相对于2中选的点的坐标)。
结果提出来的全是绝对坐标,有办法直接实现按用户坐标提吗?难道我要用计算的方法,每一个坐标点去计算一下?请老师明示,谢谢 相对坐标自己算一下不行么?
不管软件支持不支持,尽量少用别的坐标系,脑子稍微不清晰的人,很容易犯错,忘记了自己当前是那个坐标系,结果错位。
页:
[1]